package dlc;

import java.util.*;

/**
 * ,        .
 */

public class Program{

    /**
     *  ,      / 
     * ( ConditionForChecking)
     */
    private Vector m_Conditions = new Vector();//(   )

    /**
     *      m_Conditions
     * ( CheckingResult)
     */
    private Vector m_Response = new Vector();

    /**
     *  
     */
    private String m_program = "";

	/**
	 *        Processor
	 */
	public class ProgramThread extends Thread{

		Processor m_proc;
		String    m_input;
		String    m_output;
		String  []m_outputRef;
		boolean   m_bRes = false;

		boolean   m_bStopped = false;

		/**
		 *  
		 * @param proc   Processor
		 * @param input   
		 * @param output    
		 * @param outputRef  ,         
		 */
		public ProgramThread( Processor proc, String input, String output, String []outputRef ){
			m_proc = proc;
			m_input = input;
			m_output = output;
			m_outputRef = outputRef;
		}

		/**
		 *   Thread.  Processor.run,     
		 */
		public void run(){

			try{
				m_bRes = m_proc.run( m_input, m_output );
				m_outputRef[0] = m_proc.getOutput();
			}catch( Exception exc ){
				m_bRes = false;
				m_outputRef[0] = "0";
			}

			m_bStopped = true;
		}

		/**
		 *      
		 */
		public boolean  getResult(){ return m_bRes; }
		/**
		 *         
		 */
		public String   getOutput(){ return m_outputRef[0]; }
		/**
		 *       (      Processor.run)
		 */
		public boolean  isStopped(){ return m_bStopped; }
	}

    /**
     *   
     */
    public void addCondition(ConditionForChecking cond) {
        m_Conditions.add((ConditionForChecking) cond);
    }

    /**
     *     
     * @param code  
     */
    public void setCode( String code ){
        if( code == null )
            m_program = "";
        else
            m_program = code;
    }

    /**
     * ,        
     * @return   CheckingResult
     */
    public Vector runForCheck( Processor proc ) {

        try{

			proc.init( m_program );

//Logger.log("\t - Starting. Total count of condition: " + m_Conditions.size() );

	        for( int i = 0; i < m_Conditions.size(); i++ ){

	            CheckingResult chResult = new CheckingResult();
	            ConditionForChecking cfCheck = (ConditionForChecking)m_Conditions.elementAt(i);
	            chResult.setID( cfCheck.getID() );
	   	        chResult.setTime( 0 );
	            chResult.setOutput( "0" );

//Logger.log("\t - running for condition: " + i + ", ID: " + cfCheck.getID() );

	            long timeLimit = cfCheck.getTime() * 1000;

				String output = "";
				try{

					// TODO:    
					// TODO:    
					// TODO:    

					String []outRef = new String[]{ output };

					ProgramThread pThread = new ProgramThread( proc, cfCheck.getInput(), cfCheck.getOutput(), outRef );
					pThread.setPriority( Thread.currentThread().getPriority() - 1 );
					pThread.start();

					long startTime = System.currentTimeMillis();

					while( (System.currentTimeMillis() - startTime) < timeLimit &&
						!pThread.isStopped() ){
						Thread.sleep( 50 );
					}
					long endTime = System.currentTimeMillis();

//Logger.log( "Terminating thread... (count=" + Thread.activeCount() + ")" );

					try{
						pThread.interrupt();
					}catch( Exception interruptExc ){}

//Logger.log( "Thread terminated! (count=" + Thread.activeCount() + ")" );

					chResult.setTime( endTime - startTime );

//Logger.log("TestSetOutput: " + cfCheck.getOutput() );
//Logger.log("UserOutput   : " + outRef[0] );

					if( pThread.getResult() )
						chResult.setResult( "1" );
					else
						chResult.setResult( "0" );
					chResult.setOutput( outRef[0] );

				}catch( Exception runExc ){
					runExc.printStackTrace();
				}

				m_Response.addElement( chResult );
	        }

		}catch( Exception exc ){
			Logger.log("Program.runForCheck( Processor ) - FAILED: " + exc.getMessage() );
		}

        return m_Response;
    }
}
