package dlc;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.xml.sax.InputSource;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * ,      .
 */
public class Server {

    Processor m_proc;
    String    m_configPath = "Config.xml";

	/**
	 *  
	 * @param confPath    
	 */
    public Server( String confPath ) {
		m_configPath = confPath;
	}

	/**
	 *    
	 * @param proc    ,   Processor
	 */
	public void startServer( Processor proc ){
		m_proc = proc;

        try {
            //  
            ConfigParser parser = new ConfigParser();
            Config config = parser.parse( m_configPath );
            if (config == null) {
                Logger.log("Server.startServer() - FAILED to read config at: " + m_configPath );
                System.exit(0);
            }
            ServerSocket ss = null;
            Socket sock = null;

            int Port = config.getPort();
            Logger.log("Port:" + Integer.toString(Port));

            ss = new ServerSocket(Port);
            while (true) {
                // 
                sock = ss.accept();

                try{
                    m_proc.processConfig( m_configPath );
                }catch( Exception exc ){
                    Logger.log( exc );
                }

                // ,     
                new ThreadForRequest(sock, config, m_proc).start();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
	}
/*
    public static void main(String args[]) {
        Logger.log("In main");
        Server server = new Server( "Config.xml" );

        try {
            //  
            ConfigParser parser = new ConfigParser();
            Config config = parser.parse("Config.xml");
            if (config == null) {
                System.exit(0);
            }
            ServerSocket ss = null;
            Socket sock = null;

            int Port = config.getPort();
            Logger.log("Port:" + Integer.toString(Port));

            ss = new ServerSocket(Port);
            while (true) {
                // 
                sock = ss.accept();

                // ,     
                new ThreadForRequest(sock, config, null).start();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
*/
}

/**
 * ,     
 */
class ThreadForRequest extends Thread {

    /**
     *   CHECK
     */
    private final int CHECK = 0;
    /**
     *   CALCULATE
     */
    private final int CALCULATE = 1;

    /**
     *    
     */
    private boolean bErrorInRequest = false;

    /**
     *  
     */
    private int ErrorCode;

    /**
     * Socket    (  ,   )
     */
    private Socket m_socket;

    /**
     *    (CHECK  CALCULATE)
     */
    private int m_Method;

    /**
     *  
     */
    private String Login = "";
    /**
     *  
     */
    private String Password = "";

    /**
     *   Config    ,    
     */
    private Config m_config;

	/**
	 *  ,   Processor
	 */
	Processor m_proc;

	/**
	 *  
	 */
    public ThreadForRequest(Socket sock, Config config, Processor proc) {
        m_socket = sock;
        m_config = config;
		m_proc = proc;
    }

// 2   (   
//Check       )

    private boolean check(Program prg) {
        return true;
    }

    private boolean calculate(Vector msg) {
        Logger.log("In Calculate ");
        return true;
    }


    private String readStringFromIS(InputStream is, int size) throws Exception {
        int ch = 0;
        int byteCount = 0;

        byte[] buffer = new byte[size];

        try {
            while (byteCount < size && (ch = is.read()) >= 0) {
                if (ch == '\b') {
                    break;
                }
                buffer[byteCount++] = (byte) ch;
            }
        } catch (Exception exc) {
            System.out.println("We block at is.read. Total bytes read: " + byteCount + "/" + size );
            throw exc;
        }

        return new String(buffer, 0, byteCount);
    }

//  XML-   
    private String getXML(InputStream in, int length) {
        Logger.log("ThreadForRequest::getXML() inputStream has " + Integer.toString(length) + " bytes");
        String str = "";

        try {

            while (length != 0) {
                m_socket.setSoTimeout(10000);

                int c = in.read();

                if (c == '\b') {
                    if (str.length() == 0) {
                        continue;
                    }
                    str = str.substring(0, str.length() - 1);
                } else {
                    str += (char) c;
                    length--;
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return str;
    }

    /**
     *     .
	 *    RLCP-,  <br>
	 * <ol>
	 * <li>ReqParser2.parse</li>
	 * <li>Program.runForCheck</li>
	 * <li> XML-   </li>
	 * </ol>
     */
    public void run() {

        OutputStream out = null;
        InputStream in = null;

        try {
            out = m_socket.getOutputStream();
            PrintWriter pw = new PrintWriter(new BufferedWriter(new OutputStreamWriter(out)), true);
            in = m_socket.getInputStream();

            //     
            String tmp = new String();

            int c;

            int nFieldCount = 0;   //   

            Hashtable htFields = new Hashtable();

/*
  
*/

            String str = "";
            while (true) {
                m_socket.setSoTimeout(10000);

                c = in.read();
                if (c == -1) {
                    Logger.log("ThreadForRequest::run - ERROR: Connection is closed ");
                    in.close();
                    out.close();
                    m_socket.close();
                    return;
                }

                if (c == 13) {
                    c = in.read();
                    nFieldCount++;

                    if (nFieldCount == 1) {
                        tmp = tmp.trim();
                        Logger.log("METOD: " + tmp);
                        if (tmp.toUpperCase().equals("CHECK")) {
                            m_Method = CHECK;
                        }
                        //   CALCULATE  
                        //    501(    )
                        else if (tmp.toUpperCase().equals("CALCULATE")) {
                            m_Method = CALCULATE;
                            out.write(("501" + "\r\n").getBytes());
                            out.flush();
                            in.close();
                            out.close();
                            m_socket.close();
                            return;
                        } else {
                            out.write(("403" + "\r\n").getBytes());
                            out.flush();
                            in.close();
                            out.close();
                            m_socket.close();
                            return;
                        }
                    }
                    if (nFieldCount > 1) {
                        StringTokenizer strTok = null;
                        if (tmp.equals("")) {
                            String szURL = (String) htFields.get("url");
                            if (szURL == null) {
                                out.write(("404" + "\r\n").getBytes());
                                out.flush();
                                in.close();
                                out.close();
                                m_socket.close();
                                return;
                            }
                            strTok = new StringTokenizer(szURL, "@");

                            if (strTok.countTokens() != 2) {
                                out.write(("402" + "\r\n").getBytes());
                                out.flush();
                                in.close();
                                out.close();
                                m_socket.close();
                                Logger.log("ERROR: error parse URL, cant find '@'");
                                return;
                            } else {

//Logger.log("URL token: " + szURL );
/**
 * TODO: fix BUG!!!!
 */

                                String a1 = strTok.nextToken();
                                strTok = new StringTokenizer( a1, "//" );
                                String a2 = strTok.nextToken();
                                //TODO: nexttoken - nexttoken BUG!!!
                                strTok = new StringTokenizer(strTok.nextToken(), ":");

//Logger.log("a1: " + a1 + ", a2: " + a2 );

                                if (strTok.countTokens() != 2) {
                                    out.write(("402" + "\r\n").getBytes());
                                    out.flush();
                                    in.close();
                                    out.close();
                                    m_socket.close();
                                    Logger.log("ERROR: error at token URL parse" );
                                    return;
                                } else {
                                    String szLogin = strTok.nextToken();
                                    String szPassword = strTok.nextToken();

                                    for (int i = 0; i < m_config.getUserInfo().size(); i++) {
                                        if (szLogin.equals(((UserInfo) m_config.getUserInfo().elementAt(i)).getLogin())) {
                                            if (szPassword.equals(((UserInfo) m_config.getUserInfo().elementAt(i)).getPassword())) {
                                                break;
                                            }
/*
                                            else {
                                                Logger.log("ERROR: Incorrect Login information");
                                                out.write(("402" + "\r\n").getBytes());
                                                out.flush();
                                                in.close();
                                                out.close();
                                                m_socket.close();
                                                return;
                                            }
*/
                                        }

                                        if (i == (m_config.getUserInfo().size() - 1)) {
                                            out.write(("402" + "\r\n").getBytes());
                                            out.flush();
                                            in.close();
                                            out.close();
                                            Logger.log("ERROR: No user accounts specified in Config.xml");
                                            m_socket.close();
                                            return;
                                        }
                                    }
                                }
                            }

                            String szLength = (String) htFields.get("content-length");
                            if (szLength == null) {
                                out.write(("404" + "\r\n").getBytes());
                                out.flush();
                                in.close();
                                out.close();
                                m_socket.close();
                                return;
                            }
                            //   str XML-  

                            //str = getXML(in, Integer.parseInt(szLength));
                            str = readStringFromIS( in, Integer.parseInt( szLength ) );
                            //Logger.log(str);
                            break;
                        }

//Logger.log("Find : at\n\t" + tmp);

                        strTok = new StringTokenizer(tmp, ":", true);
                        if (strTok.countTokens() == 1 || strTok.countTokens() == 2) {
                            out.write(("405" + "\r\n").getBytes());
                            out.flush();
                            in.close();
                            out.close();
                            m_socket.close();
                            return;
                        } else {

                            String szKey = strTok.nextToken().trim().toLowerCase();
                            strTok.nextToken();
                            String szValue = "";
                            while (strTok.hasMoreTokens()) {
                                szValue += strTok.nextToken().trim();
                            }
                            htFields.put(szKey, szValue);
                        }
                    }

                    tmp = "";
                    continue;
                } else if (c == '\b') {
                    if (tmp.length() == 0) {
                        continue;
                    }
                    tmp = tmp.substring(0, tmp.length() - 1);
                } else {
                    tmp += (char) c;
                }
            }

            m_socket.setSoTimeout(0);
//            Logger.log("Exit From While");

            if (m_Method == CHECK) {

                //         Check
                InputStream is = new ByteArrayInputStream(str.getBytes());

                //ReqParser parser = new ReqParser();

/*
     XML-
*/

                //  
//Logger.log("Input UserAnswer:\n" + str + "\n==================");
                Program prg = new ReqParser2().parse( str );
                if (prg == null) {
                    out.write(("400" + "\r\n").getBytes());
                    out.flush();
                    in.close();
                    out.close();
                    m_socket.close();
                    return;
                }

//      ( )  

                Vector Res = new Vector();
                try{
                    Res = prg.runForCheck( m_proc.newInstance() );
                }catch( Exception e ){
                    //e.printStackTrace();
                    Logger.log("ERROR: ThreadForRequest processing FAILED (at runForCheck): " + e.getMessage() );
                }

                if (Res == null) {
                    out.write(("401" + "\r\n").getBytes());
                    out.flush();
                    in.close();
                    out.close();
                    m_socket.close();
                    return;
                }

                // XML- 
                Document document = DocumentHelper.createDocument();
//                document.addDocType("Response", null, "http://de.ifmo.ru/--DTD/Response.dtd");

                Element response = document.addElement("Response");
                for (int i = 0; i < Res.size(); i++) {
                    Element ChRes = response.addElement("CheckingResult");
                    ChRes.addAttribute("id", ((CheckingResult) Res.elementAt(i)).getID());
                    ChRes.addAttribute("Time", ((CheckingResult) Res.elementAt(i)).getTime());
                    ChRes.addAttribute("Result", ((CheckingResult) Res.elementAt(i)).getResult());
                    ChRes.addComment((String) ((CheckingResult) Res.elementAt(i)).getOutput());
                }

                int iLength = document.asXML().getBytes().length;
                String XMLResponse = "200" + "\r\n";
                XMLResponse += "Content-Length:" + Integer.toString(iLength) + "\r\n\r\n";
                XMLResponse += document.asXML();

//                Logger.log("Response:\n" + XMLResponse);
                out.write(XMLResponse.getBytes());
/*
                FileOutputStream fos = new FileOutputStream( "c:\\temp\\cohlab_server.out" );
                fos.write( XMLResponse.getBytes() );
                fos.close();
*/

            } else if (m_Method == CALCULATE) {
                //calculate( message );
            } else {
                out.write("Error in Request".getBytes());
                Logger.log("Error in request");
                bErrorInRequest = true;
            }

            out.flush();
            in.close();
            out.close();

            m_socket.close();

        } catch (SocketTimeoutException e) {
            e.printStackTrace();
            try {
                in.close();
                out.close();
                m_socket.close();
            } catch (Exception ex) {
            }
            return;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
